'\" t
.\"     Title: SPI_prepare_cursor
.\"    Author: The PostgreSQL Global Development Group
.\" Generator: DocBook XSL Stylesheets v1.79.1 <http://docbook.sf.net/>
.\"      Date: 2021
.\"    Manual: PostgreSQL 9.6.24 Documentation
.\"    Source: PostgreSQL 9.6.24
.\"  Language: English
.\"
.TH "SPI_PREPARE_CURSOR" "3" "2021" "PostgreSQL 9.6.24" "PostgreSQL 9.6.24 Documentation"
.\" -----------------------------------------------------------------
.\" * Define some portability stuff
.\" -----------------------------------------------------------------
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.\" http://bugs.debian.org/507673
.\" http://lists.gnu.org/archive/html/groff/2009-02/msg00013.html
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.ie \n(.g .ds Aq \(aq
.el       .ds Aq '
.\" -----------------------------------------------------------------
.\" * set default formatting
.\" -----------------------------------------------------------------
.\" disable hyphenation
.nh
.\" disable justification (adjust text to left margin only)
.ad l
.\" -----------------------------------------------------------------
.\" * MAIN CONTENT STARTS HERE *
.\" -----------------------------------------------------------------
.SH "NAME"
SPI_prepare_cursor \- prepare a statement, without executing it yet
.SH "SYNOPSIS"
.sp
.nf
SPIPlanPtr SPI_prepare_cursor(const char * \fIcommand\fR, int \fInargs\fR,
                              Oid * \fIargtypes\fR, int \fIcursorOptions\fR)
.fi
.SH "DESCRIPTION"
.PP
\fBSPI_prepare_cursor\fR
is identical to
\fBSPI_prepare\fR, except that it also allows specification of the planner\*(Aqs
\(lqcursor options\(rq
parameter\&. This is a bit mask having the values shown in
nodes/parsenodes\&.h
for the
options
field of
DeclareCursorStmt\&.
\fBSPI_prepare\fR
always takes the cursor options as zero\&.
.SH "ARGUMENTS"
.PP
const char * \fIcommand\fR
.RS 4
command string
.RE
.PP
int \fInargs\fR
.RS 4
number of input parameters ($1,
$2, etc\&.)
.RE
.PP
Oid * \fIargtypes\fR
.RS 4
pointer to an array containing the
OIDs of the data types of the parameters
.RE
.PP
int \fIcursorOptions\fR
.RS 4
integer bit mask of cursor options; zero produces default behavior
.RE
.SH "RETURN VALUE"
.PP
\fBSPI_prepare_cursor\fR
has the same return conventions as
\fBSPI_prepare\fR\&.
.SH "NOTES"
.PP
Useful bits to set in
\fIcursorOptions\fR
include
CURSOR_OPT_SCROLL,
CURSOR_OPT_NO_SCROLL,
CURSOR_OPT_FAST_PLAN,
CURSOR_OPT_GENERIC_PLAN, and
CURSOR_OPT_CUSTOM_PLAN\&. Note in particular that
CURSOR_OPT_HOLD
is ignored\&.
